<?php
require "../vendor/autoload.php";
require_once('config.php');

$configDataset = $config->dataset->config[0];
$connection = \Doctrine\DBAL\DriverManager::getConnection(array(
    "driver"   => "mysqli",
    "host"     => "54.207.20.59",
    "port"     => "3306",
    "user"     => "teknisa",
    "password" => "t3kn1s@",
    "dbname"   => "keeplightdb",
    "charset"  => "utf8"
));
$ordersDePara = array();
 
/*----------------------------------------------------
current_state_id	current_state_desc
1			        -- Perguntar o que é...
2                   Pagamento aceito
3                   Em Preparação
4                   Ação Pós Venda Com Sucesso
5                   Entregue
7                   Cancelado - Duplicidade
9                   Pedido pendente
10                  Aguardando pagamento por boleto
12                  Pagamento aguardando confirmação
19                  2ª via boleto

Filtro de 30 dias:
AND (invoice_date BETWEEN DATE_SUB(NOW(), INTERVAL 30 DAY) AND NOW())

$query = <<<SQL
   SELECT *
      FROM teknisa_orders, teknisa_customers
     WHERE ((current_state_id = 2) or (current_state_id = 9) or (current_state_id = 10) or (current_state_id = 12) or (current_state_id = 19))
       AND (teknisa_orders.id_customer = teknisa_customers.id_customer) 
     ORDER BY id_order limit 10
SQL;


$query = <<<SQL
   SELECT *
      FROM teknisa_orders, teknisa_customers
     WHERE (teknisa_orders.id_customer = teknisa_customers.id_customer) AND (teknisa_orders.id_order = '29945')
     ORDER BY id_order limit 10
SQL;

---------------------------------- EM USO -----------------------------------------------
$query = <<<SQL
   SELECT *
      FROM teknisa_orders, teknisa_customers
     WHERE ((current_state_id = 2) or (current_state_id = 9) or (current_state_id = 19))
       AND (teknisa_orders.id_customer = teknisa_customers.id_customer) 
     ORDER BY id_order limit 10
SQL;
-----------------------------------------------------*/

$query = <<<SQL
   SELECT *
      FROM teknisa_orders, teknisa_customers
     WHERE ((current_state_id = 2) or (current_state_id = 9) or (current_state_id = 19))
       AND (teknisa_orders.id_customer = teknisa_customers.id_customer) 
     ORDER BY id_order limit 10
SQL;

$orders = $connection->fetchAll($query, array());

var_dump($orders);die;

$ordersDePara[] = $urlKey;
$tipoInscricao = '';
$i = 0;
$acentos = array(
    'á'=>'a', 'à'=>'a', 'ã'=>'a', 'â'=>'a', 'ä'=>'a', 'é'=>'e', 'ê'=>'e', 'è'=>'e', 'ë'=>'e', 'í'=>'i', 'ì'=>'i', 'ï'=>'i',
    'î'=>'i', 'ó'=>'o', 'ô'=>'o', 'ò'=>'o', 'õ'=>'o', 'ö'=>'o', 'ú'=>'u', 'ü'=>'u', 'ù'=>'u', 'û'=>'u', 'ç'=>'c', 'Á'=>'A',
    'À'=>'A', 'Ã'=>'A', 'Â'=>'A', 'Ä'=>'A', 'É'=>'E', 'Ê'=>'E', 'È'=>'E', 'Ë'=>'E', 'Í'=>'I', 'Ì'=>'I', 'Ï'=>'I', 'Î'=>'I',
    'Ó'=>'O', 'Ô'=>'O', 'Õ'=>'O', 'Ò'=>'O', 'Ö'=>'O', 'Ú'=>'U', 'Ù'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ç'=>'C'
);
foreach ($orders as $order) {
    if (strlen($order['doc']) == 11) {
        $tipoInscricao = 'F';
    } elseif (strlen($order['doc']) == 14) {
        $tipoInscricao = 'J';
    } elseif (strlen($order['doc']) <= 5) {
        $tipoInscricao = 'O';
    } else {
        $tipoInscricao = 'I';
    }
    
    $complemento = iconv('ISO-8859-1', 'UTF-8',  $order['complemento']);
    $complementoCaixaAlta = strtoupper(strtr($complemento, $acentos));
    $rua      = iconv('ISO-8859-1', 'UTF-8', $order['address1']);
    $ruaSemAcento = strtoupper(strtr($rua, $acentos));
    $number   = $order['number'];
    $address = $ruaSemAcento.' '.$number.' '.$complementoCaixaAlta;
    $municipioCaixaAlta = strtoupper($order['city']);
    $aux = strlen($address);
    if(strlen($address) > 50){
        $address = $ruaSemAcento.' '.$number;
        if(strlen($address) > 50){
            $address = substr($address, 0, 49);
        }
    }
    $orderData                = new \stdClass;
    $orderData->PEDEXTERNO    = $order['id_order'];
    $orderData->CDCLIEEXTERNO = $order['id_customer'];
    $orderData->DTENTPED      = '';
    $orderData->VRFRETE       = $order['total_shipping'];
    $orderData->VRDESCONTO    = $order['total_discounts'];
    
    if (empty($order['payment_method'])) {
        $orderData->CDMODPGTO = $configDataset->CDMODPGTO;
    } else {
        $orderData->CDMODPGTO = $order['payment_method'];    
    }
    
    if (empty($order['id_indication'])) {
        $orderData->CDVENDEDOR = $configDataset->CDVENDEDOR;
    } else {
        if ($order['id_indication'] == 3) {
            $orderData->CDVENDEDOR = '0023';
        } elseif ($order['id_indication'] == 4) {
            $orderData->CDVENDEDOR = '0014';
        } elseif ($order['id_indication'] == 6) {
            $orderData->CDVENDEDOR = '0027';
        } elseif ($order['id_indication'] == 7) {
            $orderData->CDVENDEDOR = '0026';
        } elseif ($order['id_indication'] == 8) {
            $orderData->CDVENDEDOR = '0013';
        } elseif ($order['id_indication'] == 9) {
            $orderData->CDVENDEDOR = '0017';
        } elseif ($order['id_indication'] == 11) {
            $orderData->CDVENDEDOR = '0016';
        } else {
            $orderData->CDVENDEDOR = $configDataset->CDVENDEDOR;
        }
    }
    $ref = iconv('ISO-8859-1', 'UTF-8', $order['ref']);
    $refSemAcento = strtoupper(strtr($ref, $acentos));
    
    $firstName = iconv('ISO-8859-1', 'UTF-8', $order['firstname']);
    $firstNameSemAcento = strtoupper(strtr($firstName, $acentos));
    
    $lastName = iconv('ISO-8859-1', 'UTF-8', $order['lastname']);
    $lastNameSemAcento = strtoupper(strtr($lastName, $acentos));
    
    
    $orderData->CDCLIENTE       = $tipoInscricao.$order['doc'];
    $orderData->IDTPIJURCLIE    = $tipoInscricao;
    $orderData->NRINSJURCLIE    = $order['doc'];
    $orderData->NMRAZSOCCLIE    = iconv('ISO-8859-1', 'UTF-8', $firstNameSemAcento.' '.$lastNameSemAcento);
    $orderData->NMFANTCLIE      = iconv('ISO-8859-1', 'UTF-8', $firstNameSemAcento.' '.$lastNameSemAcento);
    $orderData->NMPAIS          = $order['country'];
    $orderData->NMESTADO        = $order['state'];
    $orderData->NMMUNICIPIO     = $municipioCaixaAlta;
    $orderData->DSENDECLIE      = $address;
    $orderData->DSCOMPENDCLI    = $complementoCaixaAlta;
    $orderData->NRCEPCLIE       = $order['postcode'];
    $orderData->DSEMAILCLIE     = $order['email'];
    $orderData->DSEMAILCLIENFE  = $order['email'];
    $orderData->DSEMAILCLIECTE  = $order['email'];
    $orderData->DSEMAILCLIEMDFE = $order['email'];
    $orderData->NRTELECLIE      = $order['phone_mobile'];
    $orderData->NRTELECLIE1     = $order['phone'];
    $orderData->DSPTOREFECLI    = iconv('ISO-8859-1', 'UTF-8', $refSemAcento);
   
    $query        = <<<SQL
                SELECT *
                  FROM teknisa_orders_detail
                 WHERE id_order = :order
                 ORDER BY id_order_detail
SQL;
    $ordersDetail = $connection->fetchAll($query, array(
        ':order' => $orders[$i++]['id_order']
        
    ));    

    $itens = [];
    foreach ($ordersDetail as $orderDetail) {
        $itens[] = array(
            'CDITPEDEXTERNO' => $orderDetail['id_order_detail'],
            'CDPRODEXTERNO'  => $orderDetail['product_id'],
            'QTITEMPED'      => $orderDetail['product_quantity'],
            'VRPREUNITPED'   => $orderDetail['product_price'],
            'DSPRODUTO'      => iconv('ISO-8859-1', 'UTF-8', $orderDetail['product_name']),
            'DSITEMPED'      => '',
            'DTENTITPED'     => ''
        );
    }
    $ordersDePara[] = array(
        'PEDEXTERNO'      => $orderData->PEDEXTERNO,
        'CDCLIEEXTERNO'   => $orderData->CDCLIEEXTERNO,
        'VRFRETE'         => $orderData->VRFRETE,
        'VRDESCONTO'      => $orderData->VRDESCONTO,
        'DTENTPED'        => $orderData->DTENTPED,
        'CDMODPGTO'       => $orderData->CDMODPGTO,
        'CDVENDEDOR'      => $orderData->CDVENDEDOR,
        
        'CDCLIENTE'       => $orderData->CDCLIENTE,
        'IDTPIJURCLIE'    => $orderData->IDTPIJURCLIE,
        'NRINSJURCLIE'    => $orderData->NRINSJURCLIE,
        'NMRAZSOCCLIE'    => $orderData->NMRAZSOCCLIE,
        'NMFANTCLIE'      => $orderData->NMFANTCLIE,
        
        'NMPAIS'          => $orderData->NMPAIS,
        'NMESTADO'        => $orderData->NMESTADO,
        'NMMUNICIPIO'     => $orderData->NMMUNICIPIO,
        'DSENDECLIE'      => $orderData->DSENDECLIE,
        'DSCOMPENDCLI'    => $orderData->DSCOMPENDCLI,
        'NRCEPCLIE'       => $orderData->NRCEPCLIE,
        'DSEMAILCLIE'     => $orderData->DSEMAILCLIE,
        'DSEMAILCLIENFE'  => $orderData->DSEMAILCLIENFE,
        'DSEMAILCLIECTE'  => $orderData->DSEMAILCLIECTE,
        'DSEMAILCLIEMDFE' => $orderData->DSEMAILCLIEMDFE,
        'NRTELECLIE'      => $orderData->NRTELECLIE,
        'NRTELECLIE1'     => $orderData->NRTELECLIE1,
        'DSPTOREFECLI'    => $orderData->DSPTOREFECLI,
        'ITENS'           => $itens,
        'NRSEQWEBSERVICE' => $urlKey['NRSEQWEBSERVICE'],
        'Cliente'         => 'Keep Light',
        'NRORG'           => $configDataset->NRORG,
        'CDFILIAL'        => $configDataset->CDFILIAL,
        'CDOPERADOR'      => $configDataset->CDOPERADOR,
        'CDPRECOBASE'     => $configDataset->CDPRECOBASE,
        'IDTIPOOPERWEB'   => $configDataset->IDTIPOOPERWEB,
        'CDTIPOOPERWEB'   => $configDataset->CDTIPOOPERWEB,
        'DSPEDVEN'        => '',
        'PRECOSITE'       => 'S'
    );
}

if (!empty($ordersDePara[1])) {
    $deParaResponse = $request->request("/registraPedido", array(
        "requestType" => "DataSet",
        "dataset" => $ordersDePara
    ));
    echo($deParaResponse);
    
} else {
    var_dump('Não há Pedidos Novos.');
}